// command(arguments, sender)
ds_map_add(global.clientCommandMap, 'help', '
    if (ds_list_size(argument0) == 1) {
        var previous, i, msg;
        previous = ds_map_find_first(global.clientCommandMap);
        msg = "OAvailable client commands: " + previous;
        for(i = 1; i < ds_map_size(global.clientCommandMap) - 1; i += 1) {
            previous = ds_map_find_next(global.clientCommandMap, previous);
            msg += ", " + previous;
        }
        msg += " and " + string(ds_map_find_next(global.clientCommandMap, previous));
        execute_string(global.addChatMessage, msg, 255, 0, argument1);

        msg = "/help";
    } else {
        msg = "/help " + chr(34) + string(ds_list_find_value(argument0, 1)) + chr(34);
    }
    if (!global.isHost) {
        execute_string(global.sendChatMessageClient, msg, 0);
    } else {  //execute the server command right away as host
        execute_string(ds_map_find_value(global.commandMap, ds_list_find_value(argument0, 0)), argument0, argument1);
    }
');
ds_map_add(global.commandMap, 'help', '
    if (ds_list_size(argument0) == 1) {
        var previous, i, msg;
        previous = ds_map_find_first(global.commandMap);
        msg = "OAvailable server commands: " + previous;
        for(i=1; i < ds_map_size(global.commandMap) - 1; i += 1) {
            previous = ds_map_find_next(global.commandMap, previous);
            msg += ", " + previous;
        }
        msg += " and " + string(ds_map_find_next(global.commandMap, previous));

        if (argument1 == global.myself) {
            execute_string(global.addChatMessage, msg, 255, 0, argument1);
        } else {
            execute_string(global.sendChatMessage, msg, 255, 0, argument1);
        }
    } else if (ds_map_exists(global.helpMap, string_lower(ds_list_find_value(argument0, 1)))) {
        msg = "O" + ds_map_find_value(global.helpMap, string_lower(ds_list_find_value(argument0, 1)));
        if (argument1 == global.myself) {
            execute_string(global.addChatMessage, msg, 255, 0, argument1);
        } else {
            execute_string(global.sendChatMessage, msg, 255, 0, argument1);
        }
    } else {
        msg = "OThis command does not have a help message or does not exist.";
        if (argument1 == global.myself) {
            execute_string(global.addChatMessage, msg, 255, 0, argument1);
        } else {
            execute_string(global.sendChatMessage, msg, 255, 0, argument1);
        }
    }
');
ds_map_add(global.helpMap, 'help', 'This command displays a list of all commands (including serverside ones). Use /help [Command] for details about that command.');

ds_map_add(global.clientCommandMap, 'host', '
    var msg;
    msg = "OThe serverhost is " + string(ds_list_find_value(global.players, 0).name) + ".";
    execute_string(global.addChatMessage, msg, 255, 0);
');
ds_map_add(global.helpMap, 'host' ,'Tells you the owner of the server.');

ds_map_add(global.clientCommandMap, 'me', '
    if (ds_list_size(argument0) > 1) {
        var msg;
        msg = chr(13) + string(ds_list_find_value(argument0, 1));

        if (!global.isHost) {
            execute_string(global.sendChatMessageClient, msg, 0);
        } else {
            execute_string(global.sendChatMessage, msg, 0, 0);
            execute_string(global.addChatMessage, msg, 0, 0);
        }
    }
');
ds_map_add(global.helpMap, 'me' , 'Completely pointless feature that allows you to chat in third person because ajf wanted it.');

ds_map_add(global.clientCommandMap, 'block', '
    var msg;

    if (!global.isHost) {
        msg = "OYou can only use this command as host";
        execute_string(global.addChatMessage, msg, 255, 0);
    } else if (ds_list_size(argument0) == 1) {
        msg = "OInvalid arguments. Type /help block for help.";
        execute_string(global.addChatMessage, msg, 255, 0);
    } else if (string_lower(ds_list_find_value(argument0, 1)) == "help") {
        msg = "OYou cannot block this command!";
        execute_string(global.addChatMessage, msg, 255, 0);
    } else if (!ds_map_exists(global.commandMap,string(ds_list_find_value(argument0, 1)))) {
        _message = "OPlease enter a valid server side command to (un)block.";
        execute_string(global.addChatMessage, msg, 255, 0);
    } else {
        var block;
        block = -1;
        if (ds_list_size(argument0) == 3) {
            block = (string(ds_list_find_value(argument0, 2)) != "0");
        } else {
            block = (ds_list_find_index(global.blockedCommands, string_lower(ds_list_find_value(argument0, 1))) == -1);
        }

        if (!block && ds_list_find_index(global.blockedCommands, string_lower(ds_list_find_value(argument0,1))) >= 0) {
            ds_list_delete(global.blockedCommands, ds_list_find_index(global.blockedCommands, string_lower(ds_list_find_value(argument0, 1))));
            msg = "OUnblocked " + ds_list_find_value(argument0, 1) + ".";
            execute_string(global.addChatMessage, msg, 255, 0);
        } else if (block && ds_list_find_index(global.blockedCommands,string_lower(ds_list_find_value(argument0, 1))) == -1) {
            ds_list_add(global.blockedCommands, string_lower(ds_list_find_value(argument0, 1)));
            msg = "OBlocked " + ds_list_find_value(argument0, 1) + ".";
            execute_string(global.addChatMessage, msg, 255, 0);
        } else {
            if (block) {
                msg = "OAlready blocked " + ds_list_find_value(argument0, 1) + ".";
            } else {
                msg = "OAlready unblocked " + ds_list_find_value(argument0, 1) + ".";
            }
           execute_string(global.addChatMessage, msg, 255, 0);
        }

        ini_open("gg2.ini");
        ini_write_real("Plugins", "chat_" + ds_list_find_value(argument0, 1), block);
        ini_close();
    }
');
ds_map_add(global.helpMap, "block", "Command that can only be used by the host to disable other commands. Use: /block <command> [1-0]");

ds_map_add(global.commandMap, 'maplist', '
    var msg, _offset;
    if (ds_list_size(argument0) == 1) {
        if (oldMapIndex != -1) {
            _offset = oldMapIndex;
        } else {
            _offset = GameServer.currentMapIndex;
        }
    } else {
        _offset = max(0, real(string_digits(string(ds_list_find_value(argument0, 1)))) - 1);
    }

    if (_offset + 10 >= ds_list_size(oldRotation)) {
        _offset = max(0, ds_list_size(oldRotation) - 10);
    }

    var i;
    msg = "OMaplist (" + string(_offset + 1) + "-" + 
            string(min(_offset + 11, ds_list_size(oldRotation))) + "/" + 
            string(ds_list_size(oldRotation)) + "): " + string(ds_list_find_value(oldRotation, _offset));
            
    for(i = _offset + 1; i < ds_list_size(oldRotation) && i < _offset + 10; i += 1) {
        msg += " - " + string(ds_list_find_value(oldRotation, i));
    }

    if (argument1 == global.myself) {
        execute_string(global.addChatMessage, msg, 255, 0);
    } else {
        execute_string(global.sendChatMessage, msg, 255, 0);
    }
');
ds_map_add(global.helpMap, 'maplist', 'This command lists 10 maps, starting from offset, or from the current map if no offset is specified  Use /maplist [offset]');
